import {
  ACAttrFilter,
  ACGuard,
  ApiPaginatedResponse,
  diskStorage,
  PageDto,
  PageMetaDto,
  PageOptionsDto,
  pick,
  UserType,
} from '@gadmin2n/nest-common';
import {
  Body,
  Controller,
  Delete,
  Inject,
  NotFoundException,
  Param,
  ParseIntPipe,
  Patch,
  Post,
  Req,
  UploadedFile,
  UseGuards,
  UseInterceptors,
} from '@nestjs/common';
import {
  ApiCreatedResponse,
  ApiNotFoundResponse,
  ApiOkResponse,
  ApiTags,
} from '@nestjs/swagger';
import { Prisma } from '@prisma/client';
import { UseRoles } from 'nest-access-control';
import { WINSTON_MODULE_PROVIDER } from 'nest-winston';
import { Logger } from 'winston';
import { CreateResourceDto } from '../../generated/resource/dto/create-resource.dto';
import {
  EffectedCount,
  ResourceFindManyArgs,
  ResourceWhereSelect,
  UploudResponse,
} from '../../generated/resource/dto/resource-types.dto';
import { UpdateResourceDto } from '../../generated/resource/dto/update-resource.dto';
import { ResourceEntity } from '../../generated/resource/entities/resource.entity';
import { ResourceService } from './resource.service';

import { ConfigService } from '@nestjs/config';
import { FileInterceptor } from '@nestjs/platform-express';

@UseGuards(ACGuard)
@Controller('resource')
@ApiTags('resource')
export class ResourceController {
  constructor(
    private readonly resourceService: ResourceService,
    private readonly config: ConfigService,
    @Inject(WINSTON_MODULE_PROVIDER) private readonly logger: Logger,
  ) {}

  @Post('createOne')
  @UseRoles({
    resource: 'resource',
    action: 'create',
    possession: 'any',
  })
  @ApiCreatedResponse({ type: ResourceEntity })
  async createOne(
    @Body() body: CreateResourceDto,
    @ACAttrFilter() acAttrFilter,
    @Req() request: Request & { user: UserType },
  ) {
    body.creator = request.user.username;
    return new ResourceEntity(
      await this.resourceService.createOne({ data: acAttrFilter(body) }),
    );
  }

  @Post('findMany')
  @UseRoles({
    resource: 'resource',
    action: 'read',
    possession: 'any',
  })
  @ApiPaginatedResponse(ResourceEntity)
  async findMany(
    @Body() body: ResourceFindManyArgs,
    @ACAttrFilter() acAttrFilter,
  ): Promise<PageDto<ResourceEntity>> {
    const { itemCount, entities } = await this.resourceService.findMany(
      body as Prisma.ResourceFindManyArgs,
    );
    const { skip = 0, take = 10 } = body as Prisma.ResourceFindManyArgs;
    const pageOptionsDto: PageOptionsDto = { skip, take };
    const pageMetaDto = new PageMetaDto({ itemCount, pageOptionsDto });

    return new PageDto(
      entities.map((item) => new ResourceEntity(acAttrFilter(item))),
      pageMetaDto,
    );
  }

  @Post('/findUnique/:id')
  @UseRoles({
    resource: 'resource',
    action: 'read',
    possession: 'any',
  })
  @ApiOkResponse({ type: ResourceEntity })
  @ApiNotFoundResponse({ description: 'Cannot found this record.' })
  async findUnique(
    @Param('id', ParseIntPipe) id: number,
    @Body() body: ResourceWhereSelect,
    @ACAttrFilter() acAttrFilter,
  ) {
    const item = await this.resourceService.findUnique(id, body);
    if (!item) {
      throw new NotFoundException();
    }
    return new ResourceEntity(acAttrFilter(item));
  }

  @Patch('updateUnique/:id')
  @UseRoles({
    resource: 'resource',
    action: 'update',
    possession: 'any',
  })
  @ApiOkResponse({ type: ResourceEntity })
  @ApiNotFoundResponse({ description: 'Cannot found this record.' })
  async updateUnique(
    @Param('id', ParseIntPipe) id: number,
    @Body() body: UpdateResourceDto,
    @ACAttrFilter() acAttrFilter,
  ) {
    /* 
    const origin = (await this.resourceService.findUnique(id, {
      id: true,
      // 这里需要根据实际情况填写
    })) as ResourceEntity | null;
    if (!origin) {
      throw new NotFoundException();
    }
    // 需要兼容从列表页change_value入口进来的情况，这里进来的是只有少量字段的数据
    const newBody = {
      ...origin,
      ...body,
    };

    // 其他个性化逻辑
    */

    const item = await this.resourceService.updateUnique(
      id,
      acAttrFilter(body),
    );
    return new ResourceEntity(acAttrFilter(item));
  }

  @Delete('deleteUnique/:id')
  @UseRoles({
    resource: 'resource',
    action: 'delete',
    possession: 'any',
  })
  @ApiOkResponse({ type: EffectedCount })
  @ApiNotFoundResponse({ description: 'Cannot found this record.' })
  async deleteUnique(@Param('id', ParseIntPipe) id: number) {
    const res = await this.resourceService.deleteUnique(id);
    if (!res.count) {
      throw new NotFoundException();
    }
    return res;
  }

  @Post('upload')
  @UseRoles({
    resource: 'resource',
    action: 'create',
    possession: 'any',
  })
  @ApiCreatedResponse({ type: UploudResponse })
  @UseInterceptors(FileInterceptor('file'))
  async uploadFile(@UploadedFile() file: Express.Multer.File) {
    const fileName = await diskStorage(
      file,
      this.config.get('media')['rootDir'] + '/resource/',
    );

    return {
      ...pick(file, ['mimetype', 'originalname', 'size']),
      url: this.config.get('media')['address'] + '/resource/' + fileName,
      name: fileName,
    };
  }
}
